#include "errors.h"
#include <signal.h>
#include "base_fct.h"
#include "keyword_fct.h"
//#include <stdlib.h>

sigset_t sigerror;

void sigerrorhandler(int sig)
{ 
  sigprocmask(SIG_UNBLOCK,&sigerror,NULL);
  longjmp(try_buf,1);
}

void sigeofhandler(int sig)
{
  printf("See you later alligator!\n");
  exit(1);
}

void init_sig()
{
  struct sigaction sa;
  sa.sa_handler = sigerrorhandler;
  sa.sa_flags = 0;
  sigemptyset(&(sa.sa_mask));
  sigaction(MYSIGERROR,&sa,NULL);

  sigemptyset(&sigerror);
  sigaddset(&sigerror,MYSIGERROR);

  sa.sa_handler = sigeofhandler;
  sa.sa_flags = 0;
  sigemptyset(&(sa.sa_mask));
  sigaction(MYSIGEOF,&sa,NULL);
}

void init()
{
  init_sig();
  init_base_fct();
  init_keyword_fct();
}

list argnberror(char *name, int n)
{
  fprintf(stderr,"** %s : wrong number of arguments : %d\n",name,n);
  raise(MYSIGERROR);
  return empty_list();
}

list argerror(char *message)
{
  fprintf(stderr,"%s",message);
  raise(MYSIGERROR);
  return empty_list();
}

list argtyperror(char *message, list l)
{
  fprintf(stderr, "%s", message);
  print_list(l);
  printf("\n");
  raise(MYSIGERROR);
  return empty_list();
}
