#include "lisp.h"
#include "list_add.h"
#include "errors.h"

char *t_str = "t";

list caar(list l)
{
  return car(car(l));
}

list cadr(list l)
{
  return car(cdr(l));
}

list cddr(list l)
{
  return cdr(cdr(l));
}

list caddr(list l)
{
  return car(cdr(cdr(l)));
}

list cadddr(list l)
{
  return car(cdr(cdr(cdr(l))));
}

list cadar(list l)
{
  return car(cdr(car(l)));
}

int length(list l)
{
  list p;
  int i = 0;
  p = l;
  while (is_a_cell(p)) {
    i++;
    p = cdr(p);
  }
  return i;
}

char *list_to_string(list l)
{
  if (is_a_name (l))
    return l->the_value.as_name;

  argerror("This is not a string !\n");
  return NULL;
}

double list_to_num(list l)
{
  if (is_a_num(l))
    return l->the_value.as_num;
  argerror("This is not a number !\n");
  return 0;
}

int is_true(list l)
{
  if (is_a_name(l))
    if (strcmp(list_to_string(l), "t") == 0)
      return TRUE;
    else return FALSE;
  else return FALSE;
}

int is_false(list l)
{
  return is_empty(l);
}

list list_true()
{
  static object t;
  t.the_type = NAME_OBJECT;
  t.the_value.as_name = t_str;
  return &t;
}

list list_false()
{
  return empty_list();
}

/* 
   void set_car(list l, list new_car)
   {
   if (is_a_cell (l))
   l->the_value.as_cell.the_car = new_car;
   else {
   fprintf (stderr, "Setting the car of something that is not a cell!\n");
   raise (MYSIGERROR);
   
   }
   }
   
   void set_cdr (list l, list new_cdr)
   {
   if (is_a_cell (l))
   l->the_value.as_cell.the_cdr = new_cdr;
   else {
   fprintf (stderr, "Setting the cdr of something that is not a cell!\n");
   raise (MYSIGERROR);
   
   }
   }
   
   list copy_list (list l)
   {
   list p, ancre; // a traduire en angliche
   
   if (is_empty (l))
   return empty_list();
   
   ancre = cons (car (l), empty_list ());
   p = ancre;
   while (!is_empty (cdr (l))) {
   set_cdr (p, cons (car (cdr (l)), empty_list ()));
   l = cdr (l);
   p = cdr (p);
   }
   return ancre;
   }
*/

int is_a_var(list l)
{
  if (!is_a_name(l)) return FALSE;
  if (strcmp(list_to_string(l),"t") == 0) return FALSE;
  return TRUE;
}

list map(list l, list (*f)(list, environment), environment env)  // Version rcursive => version itrative ....
{
  list ancre;

  if (is_empty(l)) return l;
  ancre = cons(f(car(l), env), map(cdr(l), f, env));
  /*  ancre = copy_list (l);
      p = ancre;
      while (!is_empty (p)) {
      set_car (p, f(car (p), env));
      }*/
  return ancre;
}

void free_list(list l)
{
  list p;
  list old;
  p = l;
  if (is_a_cell(p)){
    free_list(car(p));
    free_list(cdr(p));
  }
  if (is_a_name(p))
    free(p->the_value.as_name);
  free(p);
}
