/* Copyright (c) 1998 by Lip Ens-Lyon.  Tous droits reverve's */

/***
   NOM
     print
   UTILISATION

   COMMENTAIRE

   HISTORIQUE
     bouge - Dec 10, 1998: Created.
***/

#include "lisp.h"

static void     print_list_internal(list);

void
print_list(list l)
{
    switch (l->the_type) {
	case NIL_OBJECT:
	printf("()");
	return;
    case NUM_OBJECT:
	printf("%g", (l->the_value).as_num);
	return;
    case NAME_OBJECT:
	printf("%s", (l->the_value).as_name);
	return;
    case CELL_OBJECT:
	printf("(");
	print_list_internal(l);
	return;
    default:
	assert(FALSE);
    }
}

static void
print_list_internal(list l)
{
    if (is_empty(l)) {
	printf(")");
	return;
    }
    if (is_empty(cdr(l))) {
	print_list(car(l));
	printf(")");
	return;
    }
    print_list(car(l));
    printf(" ");
    print_list_internal(cdr(l));
    return;
}


void
print_newline()
{
    printf("\n");
}
