%{

  /* Fonctions de lecture des tokens rcrites avec lex 
     Laure Danthony, Mnier Clment
  */
  
#include "lisp.h"
#include "errors.h"  

static int is_empty_token = TRUE;

token x;

%}

%%
[\n\t ] ;
[(] {x.the_type = LPAR_TOKEN; return 0;}
[)] {x.the_type = RPAR_TOKEN; return 0;}
[\'] {x.the_type = QUOTE_TOKEN; return 0;}
[-+]?([0-9]+|([0-9]*\.[0-9]+))([eE][-+]?[0-9]+)? {
  x.the_type = NUM_TOKEN; 
  x.the_value.as_num = string_to_num(yytext); 
  return 0;}
[^\"()\'\n\t ]+ {
  char *s;
  x.the_type = STRING_TOKEN; 
  s = (char *) malloc(yyleng + 1); 
  assert(s != NULL); 
  strcpy(s, yytext); 
  x.the_value.as_string = s; 
  return 0;}
\".+\" {
  char *s;
  x.the_type = STRING_TOKEN; 
  s = (char *) malloc(yyleng - 1); 
  assert(s != NULL);
  yytext[yyleng - 1] = '\0';
  strcpy(s, yytext + 1);
  x.the_value.as_string = s; 
  return 0;}
. {(void) argerror("Not a valid command \n"); return 1;}
%%

token look_token()
{
  if (is_empty_token == FALSE) return x;
  is_empty_token = FALSE;
  yylex();
  return x;
}

token get_token()
{
  token t;
  t = look_token();
  is_empty_token = TRUE;
  return t;
}
